'==========================================================================
'
' NAME: FileServer_NotifyConnectedUsers.vbs
'
' AUTHOR: Dan Holme , Intelliem
' DATE  : 8/29/2007
'
' COMMENT:	Sends a message to all users connected to a server
'
' USAGE:	cscript FileServer_NotifyConnectedusers.vbs
'			/user:DOMAIN\USERNAME /password:PASSWORD
'			/server:SERVERNAME /message:"MESSAGE"
'
'	where:	user	the account with which to run the notification script
'					on the remote machine. must be a local administrator
'					and have read access to the script
'					(sScriptPath\sScriptName)
'			password	the password for the user account described above
'			server	the server name (NetBIOS or, preferably, FQDN)
'			message	the message to send to all users connected to server
'
' REQUIRES:	Message_Notification.vbs in the path indicated in the
'			configuration block.
'
' See the Windows Administration Resource Kit for documentation
'
' Neither Microsoft nor Intelliem guarantee the performance
' of scripts, scripting examples or tools.
'
' See www.intelliem.com/resourcekit for updates to this script
'
' (c) 2007 Intelliem, Inc
'==========================================================================

' CONFIGURATION BLOCK
' Path to the Message_Notification.vbs script
sScriptPath = "\\server01\data$\contoso\admin"
sScriptName = "Message_Notification.vbs"
' sTitle appears as the title bar of the message sent to users
sTitle = "NOTICE!"
' sTime is the number of seconds for which the popup message appears
sTime = 60
' Path (if not in same folder as script) and filename of psexec.exe
PSEXEC = "psexec.exe"
' Amount of time to wait for PSExec to complete, in seconds
sPSExecTimeout = 5

' Retrieve arguments passed tos cript
sComputerName = WScript.Arguments.Named("server")
sMessage = WScript.Arguments.Named("message")
sUser = WScript.Arguments.Named("user")
sPassword = WScript.Arguments.Named("password")

' If any required arguments are missing, show usage
if sComputerName = "" or sMessage = "" or sUser = "" or sPassword = "" then
	Call Usage()
end if

Set WSHShell = CreateObject("WScript.Shell")

' Connect to server
Set oServer = GetObject("WinNT://" & sComputerName & "/LanmanServer")

' Loop through each connected session and send notification
for each oSession in oServer.sessions
	sComputerToNotify = oSession.computer
	WScript.Echo "NOTIFYING " & sComputerToNotify
	iResult = SendNotification (sComputerToNotify)
	If Not iResult Then
		WScript.Echo "  ** ERROR " & iResult & " NOTIFYING " & sComputerToNotify
	End If
Next

WScript.Quit(0)

Function SendNotification(sComputerToNotify)
	sScriptCommand = """" & sScriptPath & "\" & sScriptName & """" & _
		" /message:""" & sMessage & """ /title:""" & sTitle & """ /time:" & sTime
	sPSExecCommand = """" & PSEXEC & """ \\" & sComputerToNotify & _
		" -i -u " & sUser & " -p " & sPassword & " -d wscript.exe"
	sCommand = sPSExecCommand & " " & sScriptCommand
	' DEBUG: WScript.echo sCommand
	
	Set oExec = WSHShell.Exec(sCommand)
	
	sTimeCount = 0
	Do While oExec.Status = 0
		WScript.Sleep 100
		sTimeCount = sTimeCount + 100
		If ((sTimeCount / 1000) > sPSExecTimeout) Then 
			iExitCode = -1
			Exit Do
		End If
	Loop
	
	iExitCode = oExec.ExitCode

	SendNotification = (iExitCode = 0)
End Function

Sub Usage()
	WScript.Echo "Usage: cscript FileServer_NotifyConnectedusers.vbs" & _
		" /user:DOMAIN\USERNAME /password:PASSWORD" & _
		" /server:SERVERNAME /message:""MESSAGE"""
	WScript.Quit (501)
End Sub