'==========================================================================
'
' NAME: FileServer_OpenFile.vbs
'
' AUTHOR: Dan Holme , Intelliem
' DATE  : 8/29/2007
'
' COMMENT: 	Returns information about a file and the user(s) who has/have
'			the file open.
'
' USAGE:	cscript.exe //nologo FileServer_OpenFile.vbs
'			/server:<SERVERNAME> /file:<FILENAME>
'			
'	where 	SERVERNAME:	the server's name (NetBIOS or, preferably, FQDN)
'			FILENAME:	the name (partial or complete) of the file
'
' See the Windows Administration Resource Kit for documentation
'
' Neither Microsoft nor Intelliem guarantee the performance
' of scripts, scripting examples or tools.
'
' See www.intelliem.com/resourcekit for updates to this script
'
' (c) 2007 Intelliem, Inc
'==========================================================================

sComputerName = WScript.Arguments.Named("server")
sFileName = WScript.Arguments.Named("file")

if sComputerName = "" or sFileName = "" then
	WScript.Echo "Usage: cscript FileServer_OpenFile.vbs " & _
				 "       /server:SERVERNAME /file:FILENAME"
	WScript.Quit (501)
end if

Set oServer = GetObject("WinNT://" & sComputerName & "/LanmanServer")

for each oResource in oServer.resources
	on error resume next
	if (Not oResource.User="") AND (Not Right(oResource.User,1) = "$") Then
		if Instr(1, oResource.Path, sFileName, 1) >0 then
			WScript.echo "Path: " & oResource.path
			Wscript.echo "User: " & oResource.user
			wscript.echo "Locks: " & oResource.lockcount
			Wscript.echo
		end if
	end if
next