:: ComputerOU_Delegate_Join.bat
::
:: Delegates permission for a user or group to
:: Join computers to prestaged computer accounts in an OU
::
:: Usage
:: ComputerOU_Delegate_Join.bat "<DN OF OU>" "<DOMAIN>\<USER OR GROUP>"
::
:: See the Windows Administration Resource Kit for documentation
::
:: Neither Microsoft nor Intelliem guarantee the performance
:: of scripts, scripting examples or tools.
::
:: See www.intelliem.com/resourcekit for updates to this script
::
:: (c) 2007 Intelliem, Inc.

@echo off
cls

:: Check to see whether usage is requested or required
if x%1==x? goto usage
if x%1==x/? goto usage
if x%1==x goto usage
if x%2==x goto usage

set COMPUTEROUDN=%1
set ACCT=%2

echo Delegate %ACCT% the ability 
echo to join computers to prestaged accounts
echo in %COMPUTEROUDN%
echo ----------------------------------------------------------
echo.
pause

dsacls %COMPUTEROUDN% /I:S /G %ACCT%:WS;"Validated write to DNS host name";computer
echo.
echo Check that the command completed successfully
pause
cls

dsacls %COMPUTEROUDN% /I:S /G %ACCT%:WS;"Validated write to service principal name";computer
echo.
echo Check that the command completed successfully
pause
cls

dsacls %COMPUTEROUDN% /I:S /G %ACCT%:CA;"Reset Password";computer
echo.
echo Check that the command completed successfully
pause
cls

dsacls %COMPUTEROUDN% /I:S /G %ACCT%:WP;"Account Restrictions";computer
echo.
echo Check that the command completed successfully
echo.
echo Completed.

goto:eof

:: ===========================================================================
:: USAGE EXPLANATION
:: ===========================================================================
:usage
echo Delegates permission for a user or group to
echo join computers to prestaged computer accounts in an OU
echo.
echo Usage
echo ComputerOU_Delegate_Join.bat "<DN OF OU>" "<DOMAIN>\<USER OR GROUP>"
echo
echo TIP: don't forget the DOMAIN\ portion of the account