'==========================================================================
'
' VBScript Source File -- Created with SAPIEN Technologies PrimalScript 2007
'
' NAME: Computer_InfoToDescription.vbs
'
' AUTHOR: Dan Holme , Intelliem
' DATE  : 12/16/2007
'
' USAGE:  
' cscript.exe User_Fix_CommonNames.vbs <DN of OU with users>
'
' This script sets the CN attribute of users to the format
' FIRST NAME LAST NAME
' or 
' LAST NAME FIRST NAME (if you change the code as described inline)
'
' See the Windows Administration Resource Kit for documentation
'
' Neither Microsoft nor Intelliem guarantee the performance
' of scripts, scripting examples or tools.
'
' See www.intelliem.com/resourcekit for updates to this script
'
' (c) 2007 Intelliem, Inc
'==========================================================================

Dim sOUDN

Call Arguments()

WScript.echo WScript.ScriptName
WScript.echo String(Len(WScript.ScriptName), "=")
WScript.echo
WScript.echo "Changing common name (CN) attribute of users in " & vbCrLf & sOUDN
WScript.echo
Set oTargetOU = GetObject("LDAP://" & sOUDN)
oTargetOU.Filter = Array("user")

For Each oUser In oTargetOU
		
	sLastName = ""
	sFirstName = ""
	sMiddleInit = ""
	If InStr(oUser.sAMAccountName, "$") = 0 Then
		' Filter out comptuer objects which have sAMAccountNames ending with $
		
		On Error Resume Next
		' Possible that a user doesn't have one of these properties
		sLastName = oUser.get("sn")
		sFirstName = oUser.get("givenName")
		sMiddleInit = oUser.get("initials")
		If Err.Number <> vbEmpty Then Err.Clear
		On Error Goto 0
		
		' Build common name (cn) in FirstName LastName format
		sCN = sFirstName
		If (sLastName > "" And sFirstName > "") Then sCN = sCN & " "
		sCN = sCN & sLastName
				
		' Comment out the previous three lines and uncomment the next three for LastName FirstName format
		' sCN = sLastName
		' If (sLastName > "" And sFirstName > "") Then sCN = sCN & " "
		' sCN = sCN & sFirstName
							
		If sCN > "" Then
			On Error Resume Next
			oTargetOU.MoveHere oUser.AdsPath, "cn=" & sCN 
			If Err.number <> vbEmpty Then
				WScript.Echo "** ERROR ** renaming " & oUser.cn
				WScript.Echo "**          possibly due to a conflict with an existing user with the same common name (CN)."
				Err.Clear
			Else
				WScript.Echo sCN
			End If
			On Error Goto 0
		Else
			WScript.Echo "** ERROR ** did not change: " & oUser.cn
			WScript.Echo "**          because the new name would have been blank."
		End If
		
	End If

Next

Sub Arguments()
	Dim oArgs
	Set oArgs = WScript.Arguments
	If oArgs.Count <> 1 Then 
		Call Usage()
	Else
		sOUDN = oArgs(0)
	End If
End Sub

Sub Usage()
	WScript.Echo
	WScript.Echo "Usage:   cscript.exe " & WScript.ScriptName & vbCrLF & "    <DN of OU in which to change user common names>" 
	WScript.Echo 
	WScript.Echo "Example: cscript.exe " & WScript.ScriptName & vbCrLf & "    ""ou=Employees,dc=contoso,dc=com"""
	WScript.Quit(0)
End Sub