'==========================================================================
'
' VBScript Source File -- Created with SAPIEN Technologies PrimalScript 2007
'
' NAME: 
'
' AUTHOR: Dan Holme , Intelliem
' DATE  : 12/16/2007
'
' USAGE:  
' cscript.exe User_ShowEmployeeNumber_v3.vbs <ADsPath of user>
'
' This script displays the employeeNumber attribute
' (or any other single-valued attribute specified by sAttribute)
' and allows you to change that attribute
'
' See the Windows Administration Resource Kit for documentation
'
' Neither Microsoft nor Intelliem guarantee the performance
' of scripts, scripting examples or tools.
'
' See www.intelliem.com/resourcekit for updates to this script
'
' (c) 2007 Intelliem, Inc
'==========================================================================

Option Explicit
Const ADS_PROPERTY_CLEAR = 1

Dim sObjectADsPath, oObject, sAttribute, sValue, sPrompt, sNewValue
sAttribute = "employeeNumber"
If WScript.Arguments.Count = 0 Then
    WScript.Echo "Usage: cscript.exe " & WScript.ScriptFullName & _
         " <ADsPath of user>"
    WScript.Quit(0)
End If

sObjectADsPath = WScript.Arguments(0)
On Error Resume Next
Set oObject = GetObject(sObjectADsPath)
If Err.Number <> 0 Then
    WScript.Echo "The ADsPath provided is invalid:" & vbCrLf & _
        sObjectADsPath & vbCrLf & "Error " & Err.Number & _
        vbCrLf & Err.Description
    WScript.Quit(0)
End If
On Error Goto 0

On Error Resume Next
sValue = oObject.Get(sAttribute)
If Err.Number <> 0 Then
    sPrompt = "There is no current value for " & sAttribute
    sValue = ""
Else
    sPrompt = "The current value for " & sAttribute & " is" & vbCrLf & _
               sValue
End If
On Error Goto 0
sNewValue = InputBox(sPrompt, sAttribute, sValue)

If sNewValue <> sValue Then
    On Error Resume Next
    If sNewValue > "" Then
        oObject.Put sAttribute, sNewValue
        oObject.SetInfo
    Else
    	If MsgBox("Do you want to delete the current value, " & sValue, vbYesNo, "Confirm deletion") = vbYes then
        	oObject.PutEx ADS_PROPERTY_CLEAR, sAttribute, 0
        	oObject.SetInfo
        End If
    End If
    If Err.Number <> 0 Then 
        WScript.Echo "Error changing value of " & sAttribute
        WScript.Quit(0)
    End If
End If


