'==========================================================================
'
' VBScript Source File -- Created with SAPIEN Technologies PrimalScript 2007
'
' NAME: Config_FolderView_Details.vbs
'
' AUTHOR: Dan Holme , Intelliem
' DATE  : 11/21/2007
'
' USAGE:  
' cscript.exe Config_FolderView_Details.vbs
'
' Sets the default folder view to DETAILS for all folders on the computer
' then resets a few select folders (e.g. Pictures, Control Panel, 
' My Computer, Network Places) to other views appropriate for those folders
'
' RUN ON WINDOWS XP (Not Vista, since it has different folders)
'
' Demonstrates how to use SendKeys and AppActivate to automate
' a GUI click-by-click (keystroke-by-keystroke) configuration change
'
' See the Windows Administration Resource Kit for documentation
'
' Neither Microsoft nor Intelliem guarantee the performance
' of scripts, scripting examples or tools.
'
' See www.intelliem.com/resourcekit for updates to this script
'
' (c) 2007 Intelliem, Inc
'==========================================================================

Option Explicit
Dim WSHShell,iObserve,iWinWait,iWait,sMessage,iButton
iObserve=4000
iWait=2000
iWinWait=10000

' ==============================================
' SET FOLDER VIEWS TO DETAILS WITH EXCEPTIONS
' ==============================================

set WSHShell=WScript.CreateObject("WScript.Shell")

sMessage = "A 'macro' will run to configure the folder views. " & _
  "It is VERY important that you do not touch your system until the " & _
  "macro is complete.  Click OK to begin the macro, then wait."
iButton = WSHShell.Popup (sMessage,5,"Pausing",64)

' Set one folder to details view so we can then "apply to all"
' I picked the HELP folder
WSHShell.Run "c:\windows\help"
WScript.Sleep iWinWait
WSHShell.AppActivate "help"
WScript.Sleep iObserve
WSHShell.SendKeys "%VD"
WScript.Sleep iObserve
' Arrange by size so that...
WSHShell.SendKeys "%VIS"
WScript.Sleep iObserve
' We can then arrange by name and be confident
' it will be in ascending order.  If we didn't
' sort by something else first, and the folder
' is already sorted by name, we could end up
' with descending order
WSHShell.SendKeys "%VIN"
WScript.Sleep iObserve

' Open the Folder Options dialog box
' (there are more elegant ways to do this)
WSHShell.SendKeys "%TO"
WScript.Sleep iWait
WSHShell.AppActivate "Folder Options"
' Go to the View tab and "apply to all"
WSHShell.SendKeys "^{TAB}"
WScript.Sleep iWait
WSHShell.SendKeys "L"
WScript.Sleep iWait
WSHShell.AppActivate "Folder Views"
WSHShell.SendKeys "Y"
WScript.Sleep iWait
WSHShell.SendKeys "+{TAB}+{TAB}"
WSHShell.SendKeys "{ENTER}"
WScript.Sleep iWait
WSHShell.AppActivate "help"
WSHShell.SendKeys "%{F4}"

' Change My Pictures to Thumbnails
WSHShell.Run "explorer.exe ""%userprofile%\my documents\my pictures"""
WScript.Sleep iWinWait
WSHShell.AppActivate "My Pictures"
WSHShell.SendKeys "%VH"
WScript.Sleep iObserve
WSHShell.SendKeys "%{F4}"

' Change My Computer to tiles
WSHShell.Run "explorer.exe /n,::{20D04FE0-3AEA-1069-A2D8-08002B30309D}"
WScript.Sleep iWinWait
WSHShell.AppActivate "My Computer"
WSHShell.SendKeys "%VS"
WScript.Sleep iObserve
WSHShell.SendKeys "%VIT"
'WScript.Sleep iObserve
'WSHShell.SendKeys "%VIG"
WScript.Sleep iObserve
WSHShell.SendKeys "%{F4}"

' Change Network Places
WSHShell.Run "explorer.exe /n,::{208D2C60-3AEA-1069-A2D7-08002B30309D}"
WScript.Sleep iWinWait
WSHShell.AppActivate "My Network Places"
WSHShell.SendKeys "%VS"
WScript.Sleep iObserve
WSHShell.SendKeys "%VI{DOWN}{DOWN}{DOWN}{ENTER}"
WSHShell.SendKeys "%VIG"
WScript.Sleep iObserve
WSHShell.SendKeys "%{F4}"

' Change Network Connections
WSHShell.Run "explorer.exe /n,::{7007ACC7-3202-11D1-AAD2-00805FC1270E}"
WScript.Sleep iWinWait
WSHShell.AppActivate "Network Connections"
WSHShell.SendKeys "%VS"
WScript.Sleep iObserve
WSHShell.SendKeys "%{F4}"

' Change Control Panel (which should be in CLASSIC view prior to running this script)
WSHShell.Run "control.exe"
WScript.Sleep iWinWait
WSHShell.AppActivate "Control Panel"
WSHShell.SendKeys "%VS"
WScript.Sleep iObserve
WSHShell.SendKeys "%{F4}"

sMessage = "Thank you. The macro is complete. Click OK to continue."
iButton = WSHShell.Popup (sMessage,2,"Pausing",64)
